// Network Racer
// By Jum Hig 97/98
// started: 24/10/97
// updated: 14/2/98

// Notes: 	- start by choosing car (key 1-4) (time limit)
//          - first to choose car can start game earlier
//				-




#include <stdlib.h>
#include <stdio.h>
#include <math.h>

#include "allegro.h"							// Allegro library
#include "racer.h"							// main header
#include "racerdat.h"						// header for datafile
#include "jonipx.h"							// header for IPX library
#include "dosbuff.h"							// also need this


// define structures for tile and track
typedef struct {
	int block;
   int rotn;
} tile_type;

typedef struct {
	int width;
   int height;
   int start_x;
   int start_y;
   int start_rotn;
	tile_type tile[20][20];
} track_type;

track_type track;
Point2D_type checkpoint[20];
int numcheckpoints;

char mystring[80];
PALETTE mypalette;
RGB white = { 63, 63, 63 };
BITMAP *buffer;
BITMAP *background;							// holds background and track
DATAFILE *datafile;							// our datafile
SAMPLE *pengine;								// engine noise sample

// create some useful fixed point numbers, and our framecount variables
fixed fzero, fpnt5, fone, f2, f255, f256;
volatile int framecount;
volatile int fps;

// prototypes for functions 
int Load_Track(void);
void DrawCheckPoints(void);
void DrawTileMap(int width, int height);

// timer interrupt function to count fps
void mytimerhandler()
{
	fps = framecount;
	framecount = 0;
}

END_OF_FUNCTION(mytimerhandler);

void main()
{
	int i, j, k, x, y, n;
	int tracknum = 0;
   int gameover, gamestarted, greenlight;
   int mycar, playernumber;
   int offset_x, offset_y;
   int bgcolour, old_rtr_cnt;
	int selected[5];
   node_address_type othersaddr[4];
   int othercars[4];
   int nextcheckpoint, lapsdone, lapsinrace, winner;
	int sp_offset_x[4][4] = { 20, 40, 20, 40, 20, 40, 20, 40, 20, 40, 20, 40, 25, 40, 20, 40 };
	int sp_offset_y[4][4] = { 20, 20, 40, 40, 20, 20, 40, 40, 20, 20, 40, 40, 62, 20, 40, 40 };
   fixed accn, drag, wheelrotn;

	Racer_type car[4];
   game_packet_type packet;
   string_type string;
   char mystring[80];
   // This node address means broadcast to everyone
   node_address_type node_address = { 0xff, 0xff, 0xff, 0xff, 0xff, 0xff };


   fzero = ftofix(0.000);
   fpnt5 = ftofix(0.5);
   fone = itofix(1);
   f2 = itofix(2);
   f255 = itofix(255);
   f256 = itofix(256);

   // Initialise IPX stuff
   Allocate_Dos_Buffers();
   if( !Init_Jonipx() ) {
   	printf("Error - Unable to initialise IPX !\n");
      exit(0);
	}

	// Initialise Allegro etc
	allegro_init();
	install_timer();
	install_keyboard();

	// set up sound and load samples
	i=install_sound(DIGI_AUTODETECT, MIDI_AUTODETECT, NULL);
	pengine = load_sample("engine.wav");


	// load datafile
	printf("Loading and decompressing datafile...\n");
	datafile = load_datafile("racer.dat");
	if(!datafile) {
		allegro_exit();
		printf("Error loading datafile racerdat.dat!\n\n");
		exit(1);
	}


	delay(2000);
   // clear tilemap (avoids problems later)
   for(i=0; i < 20; i++) {
   	for(j=0; j < 20; j++) track.tile[i][j].block = 0;
	}

	// set graph mode and palette
	set_gfx_mode(GFX_VGA, 320, 200, 0, 0);
	set_palette(datafile[PAL_RACER].dat);
	// allocate the double and triple buffer bitmaps
	buffer = create_bitmap(SCREEN_W, SCREEN_H);
	background = create_bitmap(TRACK_W, TRACK_H);

   gui_fg_color = 2;
   gui_bg_color = 3;

	// install frame counter handler
   LOCK_VARIABLE(fps);
	LOCK_VARIABLE(framecount);
	LOCK_FUNCTION(mytimerhandler);
	i = install_int(mytimerhandler, 1000);
	framecount = 0;

	// ---------------------------------------------------------------------
	// --------------------------- Main Prog Loop --------------------------
	// ---------------------------------------------------------------------

   // ********************* select car / join game routine *************************
	//
   text_mode(0);
	clear(buffer);
	for(i=199; i>20; i--) {
		textout_centre(buffer, datafile[FNT_JUM].dat, "TURBO RACER IV", 160, i, -1);
		blit(buffer, screen, 0, 0, 0, 0, 320, 200);
	}

   clear(background);
	textout_centre(background, datafile[FNT_JUM].dat, "TURBO RACER IV", 160, 20, -1);
	textout_centre(background, font, "Choose your Racer (Press 1-4):", 160, 55, 1);
	textout_centre(background, font, "Press SPACE to start game.", 160, 182, 2);

   gamestarted = 0;
   for(i=1; i<5; i++) selected[i] = 0;
   mycar = 0; playernumber = 1;
   while(!gamestarted) {

		blit(background, buffer, 0, 0, 0, 0, 320, 200);
		// draw cars for selection
      for(i=1; i<5; i++) {
         if(!selected[i]) {
         	car[i].rotn += fone;
      		rotate_sprite(buffer, datafile[RACER_1A + i*2 - 2].dat, -56 + i*80, 108, car[i].rotn);
			}
         else {
         	if(i == mycar) stretch_sprite(buffer, datafile[RACER_1A + i*2 - 2].dat, -72 + i*80, 92, 64, 64);
		      else draw_sprite(buffer, datafile[RACER_1A + i*2 - 2].dat, -56 + i*80, 108);
         	sprintf(mystring, "%d", selected[i]);
            textout_centre(buffer, font, mystring, -40 + i*80, 168, 3);
			}
		}

		sprintf(mystring, "Track %d", tracknum);
		textout_centre(buffer, font, mystring, 160, 172, 3);
		vsync();
		blit(buffer, screen, 0, 0, 0, 0, 320, 200);
		// check if player has selected a car
      if(!mycar) {
			if(key[KEY_1] && !selected[1]) { mycar = 1; selected[1] = playernumber; }
      	if(key[KEY_2] && !selected[2]) { mycar = 2; selected[2] = playernumber; }
         if(key[KEY_3] && !selected[3]) { mycar = 3; selected[3] = playernumber; }
         if(key[KEY_4] && !selected[4]) { mycar = 4; selected[4] = playernumber; }
		}

		// if player has selected a car, send info out to other players
      // (NB: keep on sending info in case someone joins after you've selected)
		if(mycar) {
         string[0] = IPX_JOIN_GAME;
         string[1] = playernumber;				// your player number
         string[2] = mycar;							// the car you chose (1-4)
         Jon_Send_Packet(string, 3, node_address);
		}

      // check for other players selecting a car or starting the game
      if( Packet_Ready() ) {
      	Pop_Packet( &packet );
         // print to stderr
         //fprintf(stderr, "%d %d %d\n", packet.string[0], packet.string[1], packet.string[2]);
         if(packet.string[0] == IPX_JOIN_GAME) {
            // select car for other player if not already
            if(!selected[packet.string[2]]) {
					selected[packet.string[2]] = packet.string[1];
            	//strcpy(othersaddr[packet.string[2]], packet.source_node);
               fprintf(stderr, "Player join: Car %d Player num %d\n", packet.string[2], packet.string[1]);
            	// increment player number if you haven't chosen
            	if(!mycar) playernumber++;
				}
			}
      	if(packet.string[0] == IPX_START_GAME) {
         	// enter game if car selected, otherwise wait till next game
				if(mycar) gamestarted = 2;
            else {
            	gamestarted = 0;
			   	for(i=1; i<5; i++) selected[i] = 0;
			   	mycar = 0; playernumber = 1;
				}
			}
		}


		// option to quit already
		if(key[KEY_ESC]) {
			Close_Jonipx();
			exit(0);
		}

      // start game with space bar (only if you have already selected a car)
		if(key[KEY_SPACE] && mycar) {
			gamestarted = 1;
         string[0] = IPX_START_GAME;
			Jon_Send_Packet(string, 1, node_address);
		}

   }

   // show players car assignments and node addresses
   for(i=1; i<5; i++) {
   	fprintf(stderr, "%d  %x %x %x %x %x %x\n", selected[i], othersaddr[i][0],
      	othersaddr[i][1], othersaddr[i][2], othersaddr[i][3], othersaddr[i][4],
         othersaddr[i][5]);
	}

	// Load a track
	// NB: THIS HAS TO BE FIXED - player who starts game must select a track,
	//     then this track name is sent to other players' PC's, which load
	//     that track.
   i = Load_Track();

   rest(1000);

	//
   // ****************************** main game loop *****************************
	//
	// initialise some variables
   car[mycar].speed = fzero;
   car[mycar].x = itofix(track.start_x * 80 + sp_offset_x[track.start_rotn/64][selected[mycar]-1]);
   car[mycar].y = itofix(track.start_y * 80 + sp_offset_y[track.start_rotn/64][selected[mycar]-1]);
   fprintf(stderr, "mycar selected: %d", selected[mycar]);
   car[mycar].rotn = itofix(track.start_rotn);
   car[mycar].drag_coeff = ftofix(0.02);
	nextcheckpoint = 0;					// first check point
	lapsinrace = 3;
	lapsdone = 0;
   gameover = 0;
	greenlight = 210;
   old_rtr_cnt = retrace_count;
	text_mode(-1);
	play_sample(pengine, 128, 128, 100, TRUE);			// start engine sample
   while(!gameover) {

		// decrement greenlight if you started game, and
      // send green flag counter message
		if(gamestarted == 1) {
			greenlight--;
			sprintf(string, "%c%c", IPX_GREEN_LIGHT, greenlight);
			Jon_Send_Packet(string, 2, node_address);
			if(!greenlight) gamestarted = 0;
		}

      accn = fzero;
      // get color of pixel car is over
      bgcolour = getpixel(background, fixtoi(car[mycar].x), fixtoi(car[mycar].y));

		// Get keyboard  User input and respond
		if(key[KEY_LEFT]) {
			car[mycar].rotn -= fone;
         if(car[mycar].rotn < fzero) car[mycar].rotn = itofix(255);
		}
		if(key[KEY_RIGHT]) {
			car[mycar].rotn += fone;
         if(car[mycar].rotn > f255) car[mycar].rotn = fzero;
		}
		if(key[KEY_A] && !greenlight) {
    		accn = ftofix(0.003);         // apply initial power (for grass etc)
      	if(bgcolour < 16) {				// apply power curve
				accn += fmul(car[mycar].speed, ftofix(0.04));
			}
		}
		if(key[KEY_Z]) {
			if(car[mycar].speed > fzero) accn = ftofix(-0.01);
		}
		if(key[KEY_X]) ;
		if(key[KEY_S]) ;

      // usual option for woosies to quit
		if(key[KEY_ESC]) {
			Close_Jonipx();
			gameover = 1;
		}

      // ******** car motion dynamics **********
      // apply drag (wind resist + tyre drag)
      drag = fmul(car[mycar].drag_coeff, fmul(car[mycar].speed, fabs(car[mycar].speed)));
      if(car[mycar].speed > fzero) drag += ftofix(0.0005);

      car[mycar].speed += accn - drag;
      //if(car[mycar].speed < fzero) car[mycar].speed = fzero;
      car[mycar].wheelrotn += fdiv(car[mycar].speed, f2);
      if(car[mycar].wheelrotn > f256) car[mycar].wheelrotn = fzero;

      // move players car
      car[mycar].x += fmul(car[mycar].speed, fsin(car[mycar].rotn));
      car[mycar].y -= fmul(car[mycar].speed, fcos(car[mycar].rotn));

		// adjust engine tone according to car speed
		adjust_sample(pengine, 128, 128, 300 + fixtoi(fmul(car[mycar].speed, f256)), TRUE);

      // try to get mycar to centre of screen
		offset_x = fixtoi(car[mycar].x) - 160;
      if(offset_x < 0) offset_x = 0;
      if(offset_x > (TRACK_W - 320)) offset_x = (TRACK_W - 320);
      offset_y = fixtoi(car[mycar].y) - 100;
      if(offset_y < 0) offset_y = 0;
      if(offset_y > (TRACK_H - 200)) offset_y = (TRACK_H - 200);
		// copy background to buffer (instead of clear)
		blit(background, buffer, offset_x, offset_y, 0, 0, SCREEN_W, SCREEN_H);

		// check for checkpoint and correct checkpoint sequence
		for(i=0; i<numcheckpoints; i++) {
      	if(abs(fixtoi(car[mycar].x) - checkpoint[i].x) < 50) {
         	if(abs(fixtoi(car[mycar].y) - checkpoint[i].y) < 50) {
			      sprintf(mystring, "CP: %2d Next: %2d", i, nextcheckpoint);
			      textout(buffer, font, mystring, 2, 32, 1);
					if(i == nextcheckpoint) {
               	nextcheckpoint++;
                  if(nextcheckpoint == numcheckpoints) {
                  	lapsdone++;
                  	nextcheckpoint = 0;
						}
					}
				}
			}
		}

      // draw cars as rotated sprites
      for(i=1; i<5; i++) {
      	if(selected[i]) {						// only draw if exists
				rotate_sprite(buffer, datafile[RACER_1A + i*2 - 2 + (fixtoi(car[mycar].wheelrotn) % 2)].dat, fixtoi(car[i].x) - offset_x - 16, fixtoi(car[i].y) - offset_y - 16, car[i].rotn);
			}
		}
      // * DEBUG * print your player number and car no. onscreen
      sprintf(mystring, "Plr %d  Car %d BGC %d GL %d", playernumber, mycar, bgcolour, greenlight);
      textout(buffer, font, mystring, 0, 0, 2);
      sprintf(mystring, "fps %d rc %d", fps, retrace_count);
      textout_centre(buffer, font, mystring, 260, 0, 1);
      sprintf(mystring, "Ac %1.3f  Dr %1.3f  Sp %1.3f Lp %2d", fixtof(accn), fixtof(drag), fixtof(car[mycar].speed), lapsdone);
      textout(buffer, font, mystring, 0, 10, 1);
      sprintf(mystring, "Laps %2d", lapsdone);
      textout(buffer, datafile[FNT_JUM].dat, mystring, 230, 180, -1);

      // wait for retrace (70 fps), then blit buffer to screen
      while(old_rtr_cnt == retrace_count) ;
      old_rtr_cnt = retrace_count;
//		vsync();								// PS: vsync deactivated 'cos slows down slower PC's
      blit(buffer, screen, 0, 0, 0, 0, 320, 200);
		framecount++;

      // Send your car's position & rotation data to other PC's on the network
      sprintf(string, "%c%c%c%c%c%c%c", IPX_PLAYER_DATA, mycar, fixtoi(car[mycar].x)/64, fixtoi(car[mycar].x) % 64, fixtoi(car[mycar].y)/64, fixtoi(car[mycar].y) % 64, fixtoi(car[mycar].rotn));
      Jon_Send_Packet(string, 7, node_address);

      // If won (completed lapsinrace laps), send "game over, I won, so nah!" packet
		if(lapsdone == lapsinrace) {
			sprintf(string, "%c%c", IPX_END_GAME, mycar);
			Jon_Send_Packet(string, 2, node_address);
			gameover = 2;
		}

      // Get positions of other cars from network
      while( Packet_Ready() ) {
      	Pop_Packet( &packet );
/*         fprintf(stderr, "%x %x %x %x %x %x   %d %d %d %d %d %d %d\n", packet.source_node[0], packet.source_node[1],
         	packet.source_node[2], packet.source_node[3], packet.source_node[4], packet.source_node[5],
         	packet.string[0], packet.string[1], packet.string[2], packet.string[3],
            packet.string[4], packet.string[5], packet.string[6]);
*/			switch(packet.string[0]) {
            case IPX_END_GAME :
               	gameover = 3;
						winner = packet.string[2];
               	break;
				case IPX_PLAYER_DATA :
						n = packet.string[1];			// get other players car no.
                  car[n].x = itofix(packet.string[2] * 64 + packet.string[3]);
                  car[n].y = itofix(packet.string[4] * 64 + packet.string[5]);
						car[n].rotn = itofix(packet.string[6]);
                  break;
				case IPX_GREEN_LIGHT :
                  greenlight = packet.string[1];
                  break;

			}
		}

   }

	text_mode(-1);
   switch(gameover) {
   	case 1:	sprintf(mystring,"GOODBYE");
      			break;
   	case 2:	sprintf(mystring,"YOU WON!");
      			break;
   	case 3:	sprintf(mystring,"PLAYER %d WINS", winner);
      			break;
	}
	textout_centre(screen, datafile[FNT_JUM].dat, mystring, 160, 80, -1);
	rest(3000);

	exit(0);
}

// ---------------------------------------------------------------------
// ----------------------------- End of Main ---------------------------
// ---------------------------------------------------------------------

// Load track map data
int Load_Track(void) {
	int i, j, nsc;
	char *pstring;

   pstring = datafile[MAP1].dat;

	// load checkpoints and convert
	nsc = sscanf(pstring, "%2d", &numcheckpoints);
	fprintf(stderr, "Checkpoints: %2d\n", numcheckpoints);
	pstring += 4;
	for(i=0; i<numcheckpoints; i++) {
     	nsc = sscanf(pstring, "%4d %4d", &checkpoint[i].x, &checkpoint[i].y);
		fprintf(stderr, "CP %d  X %d  Y %d\n", i, checkpoint[i].x, checkpoint[i].y);
		pstring += 11;
		checkpoint[i].x = (checkpoint[i].x * 80) / 24;
		checkpoint[i].y = (checkpoint[i].y * 80) / 24;
	}

	// load in tilemap block info
	for(i=0; i<20; i++) {
	  	for(j=0; j<20; j++) {
			nsc = sscanf(pstring, "%2d %3d", &track.tile[i][j].block, &track.tile[i][j].rotn);
			pstring += 8;
		}
	}

	// draw tilemap and check for starting grid
	DrawTileMap(20, 20);
	// draw check point flags
	DrawCheckPoints();

}

// Refresh draw all checkpoint flags
void DrawCheckPoints(void) {
	int i, j;

	// draw checkpoint flags
	for(i=0; i<numcheckpoints; i++) {
		draw_rle_sprite(background, datafile[RLE_FLAG].dat, checkpoint[i].x - 16, checkpoint[i].y - 16);
	}

	sprintf(mystring,"CP: %2d", numcheckpoints);
	textout(background, font, mystring, 510, 472, -1);

}

// Render tilemap to background, and check for start grid
void DrawTileMap(int width, int height) {
	int i, j, x, y;

	clear(background);
	for(i=0; i<width; i++) {
		for(j=0; j<height; j++) {
			// check rotation and call 90, 180 and 270 degree plot routines
         switch(track.tile[i][j].rotn) {
         	case 0:	// no rotation
            			draw_sprite(background, datafile[BLK00 + track.tile[i][j].block].dat, i*80, j*80);
							break;
				case 64:	// 64 degroids
							for(y=0; y<80; y++) {
                        for(x=0; x<80; x++) {
                           putpixel(background, i*80 + x, j*80 + y, getpixel(datafile[BLK00 + track.tile[i][j].block].dat, y, 79-x));
								}
                     }
							break;
            case 128:	// 128 degroids
            			draw_sprite_vh_flip(background, datafile[BLK00 + track.tile[i][j].block].dat, i*80, j*80);
							break;
				case 192:	// 192 degroids
							for(y=0; y<80; y++) {
                        for(x=0; x<80; x++) {
                           putpixel(background, i*80 + x, j*80 + y, getpixel(datafile[BLK00 + track.tile[i][j].block].dat, 79-y, x));
								}
                     }
							break;
			}

			if(track.tile[i][j].block == START_GRID_BLK) {
            track.start_x = i;
				track.start_y = j;
				track.start_rotn = track.tile[i][j].rotn;
            fprintf(stderr, "x %d y %d rotn %d", i, j, track.start_rotn);
			}
		}
	}

}

